-----------------------------------------
-- Auto generated by BFGen, do not edit
-----------------------------------------

--   bfgen --endian=little name=bitfield_pkg prefix=bf_ reg_prefix=r_            \
--     field_prefix=f_ --backend=vhdl3                                           \
--     --input=/opt/secbus/vhdl/hsm/bitfields/uart2maxilite.bitfield \
--     --output=bitfield_pkg.vhd
--
-- SecBus ( http://secbus.telecom-paristech.fr/ ) - This file is part of SecBus
-- Copyright (C) - Telecom ParisTech
-- Contacts: contact-secbus@telecom-paristech.fr
--
-- This file must be used under the terms of the CeCILL.
-- This source file is licensed as described in the file COPYING, which
-- you should have received as part of this distribution. The terms
-- are also available at
-- http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.txt
--



-- This package defines types, constants and sub-programs to handle interface
-- registers of a hardware peripheral. The registers all have the same bit-width.
-- They are grouped in an array and are accessed either by their index in the array
-- (their order of appearance in the source is thus important) or by their aliases
-- (name-based access).
-- 
-- As global signals are not supported for synthesis, the signal and aliases
-- declarations below are commented out. Please copy these declarations (between
-- COPY-BEGIN and COPY-END), paste them and un-comment them in the target
-- architecture declaration.
-- 
-- Direct accesses to the array of registers or to the aliases do not consider the
-- read-only bitmasks declared in the bitfield source file. They are typically
-- used when describing the read and update of the registers by the peripheral
-- itself.
-- 
-- The write and sig_write procedures provide means to write registers (variables
-- and signals respectively) with their read-only bitmasks taken into account.
-- They are typically used when describing the read and update of the registers by
-- the host CPU. Bits that are declared as read-only in the bitfield source file
-- are not overwritten by the write / sig_write procedures. The bf_<register-name>_writable
-- constants (name-based access) or the bf_reg_writable constant array
-- (index-based access) declared below can be use to raise errors or warnings when
-- the host CPU tries to write a completely read-only register.
-- 
-- The write / sig_write procedures are available in two versions: with or without
-- a mask. The version with mask performs the write operations by combining
-- (bitwise and) the bitmask derived from the bitfield source file and the
-- provided procedure parameter. The mask parameter can either be a bitwise mask
-- or a bytewise mask. The versions with mask are typically used when the CPU
-- store operations come with a set of bit (or byte) write enable.
-- 

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package bitfield_pkg is

  -- Number of registers
  constant bf_num_reg:  natural  := 9;
  -- Bit-width of register
  constant bf_reg_width: positive := 8;

  -- Type of register value
  subtype bf_reg_t is std_ulogic_vector(8 - 1 downto 0);
  -- Type of register index (bitfield source file order)
  subtype bf_reg_idx_t is natural range 0 to 9 - 1;
  -- Type of set of registers
  type bf_reg_set_t is array(bf_reg_idx_t) of bf_reg_t;
  -- Type of register address
  subtype bf_addr_t is std_ulogic_vector(32 - 1 downto 0);
  -- Type of set of register addresses (one per register)
  type bf_addr_set_t is array(bf_reg_idx_t) of bf_addr_t;
  -- Type of set of register boolean flags (one per register)
  type bf_bool_set_t is array(bf_reg_idx_t) of boolean;

  -- Register information
  -- a0:
  constant bf_a0_idx: bf_reg_idx_t := 0;
  constant bf_a0_writable: boolean := true;
  constant bf_a0_def: bf_reg_t := "00000000";
  constant bf_a0_mask: bf_reg_t := "11111111";
  constant bf_a0_addr: bf_addr_t := "00000000000000000000000000000000";
  -- a1:
  constant bf_a1_idx: bf_reg_idx_t := 1;
  constant bf_a1_writable: boolean := true;
  constant bf_a1_def: bf_reg_t := "00000000";
  constant bf_a1_mask: bf_reg_t := "11111111";
  constant bf_a1_addr: bf_addr_t := "00000000000000000000000000000001";
  -- a2:
  constant bf_a2_idx: bf_reg_idx_t := 2;
  constant bf_a2_writable: boolean := true;
  constant bf_a2_def: bf_reg_t := "00000000";
  constant bf_a2_mask: bf_reg_t := "11111111";
  constant bf_a2_addr: bf_addr_t := "00000000000000000000000000000010";
  -- a3:
  constant bf_a3_idx: bf_reg_idx_t := 3;
  constant bf_a3_writable: boolean := true;
  constant bf_a3_def: bf_reg_t := "00000000";
  constant bf_a3_mask: bf_reg_t := "11111111";
  constant bf_a3_addr: bf_addr_t := "00000000000000000000000000000011";
  -- d0:
  constant bf_d0_idx: bf_reg_idx_t := 4;
  constant bf_d0_writable: boolean := true;
  constant bf_d0_def: bf_reg_t := "00000000";
  constant bf_d0_mask: bf_reg_t := "11111111";
  constant bf_d0_addr: bf_addr_t := "00000000000000000000000000000100";
  -- d1:
  constant bf_d1_idx: bf_reg_idx_t := 5;
  constant bf_d1_writable: boolean := true;
  constant bf_d1_def: bf_reg_t := "00000000";
  constant bf_d1_mask: bf_reg_t := "11111111";
  constant bf_d1_addr: bf_addr_t := "00000000000000000000000000000101";
  -- d2:
  constant bf_d2_idx: bf_reg_idx_t := 6;
  constant bf_d2_writable: boolean := true;
  constant bf_d2_def: bf_reg_t := "00000000";
  constant bf_d2_mask: bf_reg_t := "11111111";
  constant bf_d2_addr: bf_addr_t := "00000000000000000000000000000110";
  -- d3:
  constant bf_d3_idx: bf_reg_idx_t := 7;
  constant bf_d3_writable: boolean := true;
  constant bf_d3_def: bf_reg_t := "00000000";
  constant bf_d3_mask: bf_reg_t := "11111111";
  constant bf_d3_addr: bf_addr_t := "00000000000000000000000000000111";
  -- status:
  constant bf_status_idx: bf_reg_idx_t := 8;
  constant bf_status_writable: boolean := false;
  constant bf_status_def: bf_reg_t := "00000000";
  constant bf_status_mask: bf_reg_t := "00000000";
  constant bf_status_addr: bf_addr_t := "00000000000000000000000000001000";

  constant bf_writable: bf_bool_set_t := (
    0 => true,
    1 => true,
    2 => true,
    3 => true,
    4 => true,
    5 => true,
    6 => true,
    7 => true,
    8 => false

  );
  constant bf_def: bf_reg_set_t := (
    0 => "00000000",
    1 => "00000000",
    2 => "00000000",
    3 => "00000000",
    4 => "00000000",
    5 => "00000000",
    6 => "00000000",
    7 => "00000000",
    8 => "00000000"

  );
  constant bf_mask: bf_reg_set_t := (
    0 => "11111111",
    1 => "11111111",
    2 => "11111111",
    3 => "11111111",
    4 => "11111111",
    5 => "11111111",
    6 => "11111111",
    7 => "11111111",
    8 => "00000000"

  );
  constant bf_addr: bf_addr_set_t := (
    0 => "00000000000000000000000000000000",
    1 => "00000000000000000000000000000001",
    2 => "00000000000000000000000000000010",
    3 => "00000000000000000000000000000011",
    4 => "00000000000000000000000000000100",
    5 => "00000000000000000000000000000101",
    6 => "00000000000000000000000000000110",
    7 => "00000000000000000000000000000111",
    8 => "00000000000000000000000000001000"

  );

  -- Public accessors
  procedure bf_write(r: inout bf_reg_set_t; i: bf_reg_idx_t; v: bf_reg_t);
  procedure bf_write(r: inout bf_reg_set_t; i: bf_reg_idx_t; v: bf_reg_t; m: std_ulogic_vector);
  procedure bf_sig_write(signal r: inout bf_reg_set_t; i: bf_reg_idx_t; v: bf_reg_t);
  procedure bf_sig_write(signal r: inout bf_reg_set_t; i: bf_reg_idx_t; v: bf_reg_t; m: std_ulogic_vector);

  -- Important note: as global signals are not supported for synthesis, the signal
  -- and aliases declarations below are commented out.  Please copy these
  -- declarations (between COPY-BEGIN and COPY-END), paste and un-comment them
  -- in the target architecture declaration.
  --
  ----  COPY-BEGIN
  -------------------------------------------
  ----  Auto generated by BFGen, do not edit
  -------------------------------------------
  ---- Register set
  --signal bf_reg_set: bf_reg_set_t;
  --
  ---- Register aliases
  --alias r_a0 is bf_reg_set(0);
  --alias r_a1 is bf_reg_set(1);
  --alias r_a2 is bf_reg_set(2);
  --alias r_a3 is bf_reg_set(3);
  --alias r_d0 is bf_reg_set(4);
  --alias r_d1 is bf_reg_set(5);
  --alias r_d2 is bf_reg_set(6);
  --alias r_d3 is bf_reg_set(7);
  --alias r_status is bf_reg_set(8);
  --
  ---- Field aliases
  --alias f_rxvalid is bf_reg_set(8)(0);
  --alias f_rxfull is bf_reg_set(8)(1);
  --alias f_txempty is bf_reg_set(8)(2);
  --alias f_txfull is bf_reg_set(8)(3);
  --alias f_ie is bf_reg_set(8)(4);
  --alias f_oerr is bf_reg_set(8)(5);
  --alias f_ferr is bf_reg_set(8)(6);
  --alias f_perr is bf_reg_set(8)(7);
  ---- COPY-END

end package bitfield_pkg;

package body bitfield_pkg is

  function expand8(v: std_ulogic_vector) return std_ulogic_vector is
    constant nb: natural := v'length;
    variable vv: std_ulogic_vector(nb - 1 downto 0) := v;
    variable res: std_ulogic_vector(8 * nb - 1 downto 0) := (others => '0');
  begin
    for i in 0 to nb - 1 loop
      if vv(i) = '1' then
        res(8 * i + 7 downto 8 * i) := X"ff";
      end if;
    end loop;
    return res;
  end function expand8;

  procedure bf_write(r: inout bf_reg_set_t; i: bf_reg_idx_t; v: bf_reg_t) is
    variable tmp: bf_reg_t := r(i);
  begin
    if bf_writable(i) then
      r(i) := (tmp and (not bf_mask(i))) or (v and bf_mask(i));
    end if;
  end procedure bf_write;

  procedure bf_write(r: inout bf_reg_set_t; i: bf_reg_idx_t; v: bf_reg_t; m: std_ulogic_vector) is
    variable mask: bf_reg_t;
    variable tmp: bf_reg_t := r(i);
  begin
    if(m'length = 8 * bf_reg_width) then
      mask := bf_mask(i) and expand8(m);
    else
      mask := bf_mask(i);
    end if;
    if bf_writable(i) then
      r(i) := (tmp and (not mask)) or (v and mask);
    end if;
  end procedure bf_write;

  procedure bf_sig_write(signal r: inout bf_reg_set_t; i: bf_reg_idx_t; v: bf_reg_t) is
    variable tmp: bf_reg_t := r(i);
  begin
    if bf_writable(i) then
      r(i) <= (tmp and (not bf_mask(i))) or (v and bf_mask(i));
    end if;
  end procedure bf_sig_write;

  procedure bf_sig_write(signal r: inout bf_reg_set_t; i: bf_reg_idx_t; v: bf_reg_t; m: std_ulogic_vector) is
    variable mask: bf_reg_t;
    variable tmp: bf_reg_t := r(i);
  begin
    if(m'length = 8 * bf_reg_width) then
      mask := bf_mask(i) and expand8(m);
    else
      mask := bf_mask(i);
    end if;
    if bf_writable(i) then
      r(i) <= (tmp and (not mask)) or (v and mask);
    end if;
  end procedure bf_sig_write;

end package body bitfield_pkg;
